// Generated by CoffeeScript 2.3.0
var after, cssTokenize, onError, skipRE;

cssTokenize = require('postcss/lib/tokenize');

skipRE = /^(;|comment|space)$/;

exports['.css'] = function(asset, pack) {
  var curr, deps, next, offset, prev, ref, start, tokenize, toks;
  if (asset.deps) {
    return;
  }
  tokenize = pack.tokenize || cssTokenize;
  toks = tokenize({
    css: asset.content,
    error: onError
  });
  offset = 0;
  prev = null;
  curr = null;
  next = function() {
    if (prev = curr) {
      offset += prev[1].length;
    }
    return curr = toks.nextToken();
  };
  deps = [];
  while (next()) {
    if (skipRE.test(curr[0])) {
      continue;
    }
    if (curr[0] !== 'at-word') {
      break;
    }
    if (curr[1] !== '@import') {
      break;
    }
    start = offset;
    next(); // skip ' '
    ref = next()[1].slice(1, -1);
    next(); // skip ';'
    next(); // skip '\n'
    deps.push({
      ref: ref,
      asset: null,
      start: start,
      end: offset + 1
    });
  }
  asset.deps = deps;
};


// Helpers

after = function(type, next) {
  var tok;
  while (tok = next()) {
    if (tok[0] === type) {
      return next();
    }
  }
};

onError = function(msg, line, column) {
  var e;
  e = new Error(msg);
  e.line = line;
  e.column = column;
  throw e;
};
