// Generated by CoffeeScript 2.3.0
var acorn, getRequireArg, isRequire, tt;

acorn = require('acorn');

tt = acorn.tokTypes;

exports['.js'] = function(asset) {
  var deps, next, tok, toks;
  if (asset.deps) {
    return;
  }
  toks = acorn.tokenizer(asset.content);
  next = toks.getToken.bind(toks);
  deps = [];
  while (tok = next()) {
    if (tok.type === tt.eof) {
      break;
    }
    // `import` statements are already transformed.
    if (isRequire(tok) && (tok = getRequireArg(next))) {
      deps.push({
        ref: tok.value,
        asset: null,
        start: tok.start,
        end: tok.end
      });
    }
  }
  asset.deps = deps;
};

isRequire = function(tok) {
  return (tok.type === tt.name) && (tok.value === 'require');
};

getRequireArg = function(next) {
  var tok;
  if (next().type === tt.parenL) {
    tok = next();
    if (tok.type === tt.string && next().type === tt.parenR) {
      return tok;
    }
  }
};
